import { XMLElem } from "@/util/XmlElem";
import { UABaseNode, type UABaseNodeOptions } from "./UABaseNode";

export class UAMethod extends UABaseNode {
    constructor(options: UAMethodNodeOptions) {
                    super(options);
                    this.nodeClass="Method";
    }

    static  fromXML(uaMethod: any): UAMethod{
        const bn=super.fromXML(uaMethod)
        return new UAMethod({nodeId: bn.nodeId, 
                            browseName: bn.browseName, 
                            displayName: bn.displayName,
                            references: bn.references});
    }


    toXML(): XMLElem {
        const elem =new XMLElem('UAMethod');
        elem.attr('NodeID', this.nodeId.toString())
            .attr('BrowseName', this.browseName)
            .attr('DisplayName', this.displayName);
        const refs=elem.add(new XMLElem('References'))
        for(const ref of this.references) {
            refs.add(ref.toXML());
        }
        return elem;
    }
}

export interface UAMethodNodeOptions extends UABaseNodeOptions{
   
}